/****************************************************************************
**
** Copyright (C) Datafox GmbH.
** All rights reserved.
** Contact: Datafox GmbH (develop@datafox.de)
**
** This file is part of the DFComDLL module of the Datafox SDK.
**
****************************************************************************/

#ifndef CHANNEL_BRIDGE_ARRAY_H
#define CHANNEL_BRIDGE_ARRAY_H

// Kanal - Klasse einbinden
#include "../Shared/Channel/ChannelBridge.h"

// Die oberste Klasse ist fuer Logfunktionen der DLL-Verwaltung reserviert!!!
#define MAX_CHANNEL	                401 // Maximalanzahl zu verwaltender Kanalklassen
#define LOG_CHANNEL_ID              (MAX_CHANNEL - 1)
#define ACTIVE_CHANNEL_LOWER_BOUND  251 // Untere Grenze der Aktiven Kanalklassen (ist auch maximale Anzahl der festen Kanaele)
#define ACTIVE_CHANNEL_UPPER_BOUND  (MAX_CHANNEL - 1) // Obere Grenze der Aktiven Kanalklassen (ist auch maximale Anzahl der Kanaele insgesammt)
#define MAX_ACTIVE_CHANNEL          ((MAX_CHANNEL - 1) - ACTIVE_CHANNEL_LOWER_BOUND)  // Maximalanzahl der Aktiven Kanalklassen im oberen Nummernkreis

// Verwalten der Kommunikationskanaele
class ChannelBridgeArray
{
public:
    ChannelBridgeArray();
    virtual ~ChannelBridgeArray();

    // Kanalarray ueber Indizierungsoperator verwalten
    ChannelBridge* operator[](short channelID) const
    {
        return _channels[channelID];
    }

    ChannelBridge*& operator[](short channelID)
    {
        return (ChannelBridge*&)_channels[channelID];
    }

    inline void set(int idx, ChannelBridge* channel)
    {
        _channels[idx] = channel;
    }

protected:
    ChannelBridge *_channels[MAX_CHANNEL];
};

#endif // CHANNEL_BRIDGE_ARRAY_H

