#include "DF4Crypt.h"
#ifdef _MSC_VER
#pragma warning(disable : 4996)
#endif
#include <string.h>
#include <memory.h>

CDF4Crypt::CDF4Crypt(void)
{
}

CDF4Crypt::~CDF4Crypt(void)
{
}

void CDF4Crypt::LoadCryptKey(void)
{
  unsigned char cryptKey_DF4[32] = {	
    0xc5, 0xc2, 0xc3, 0xc0, 0xc1, 0xd9, 0xdb, 0xf0, 
    0xcd, 0x07, 0xa7, 0xaf, 0xaa, 0x0a, 0x50, 0xae,
    0xc5, 0x4e, 0xc3, 0xd9, 0xaf, 0xd9, 0x09, 0xc1,
    0xa7, 0xef, 0xac, 0xc2, 0x0a, 0xbf, 0xcd, 0xae
  };

  m_binaryKey = true;
  m_size = 32;
  memcpy(m_key, cryptKey_DF4, sizeof(cryptKey_DF4));
}

void CDF4Crypt::SetKey(unsigned char *key, bool binaryKey, unsigned char size)
{
  m_binaryKey = binaryKey;
  if (binaryKey) {

    if (size > sizeof(m_key))
      size = 32;

    memset(m_key, 0, sizeof(m_key));
    m_size = size;
    memcpy(m_key, key, size);
  } else {

    strcpy((char*)m_key, (char*)key);
    m_size = 0;
  }
}

// ##################################################################
/**
* @brief Initialisiert die sbox fuer die Crypt-Verschlusselungsroutine.
*/
void CDF4Crypt::Init()
{
  unsigned i, j;
  unsigned char *kptr = m_key, trans;

  //	ASSERT(sizeof(m_sbox) == 256);
  //	ASSERT(sizeof(m_k) == 256);

  for(i=0; i < 256; i++) {		

    m_sbox[i] = (unsigned char)i;
  }

  for(i=0; i < 256; i++) {

    m_k[i] = *kptr;
    kptr++;

    if (m_binaryKey) {

      if(kptr == (m_key + m_size)) {

        kptr = m_key;
      }
    } else {

      if (*kptr == 0) {

        kptr = m_key;
      }
    }
  }

  for(i=0, j=0; i < 256; i++) {

    j = (j + m_sbox[i] + m_k[i]) % 256;
    trans = m_sbox[i];
    m_sbox[i] = m_sbox[j];
    m_sbox[j] = trans;
  }
}

// ##################################################################
/**
* @brief Ver-/Entschluesselt die uebergebenen Daten.
*/
void CDF4Crypt::Crypt(unsigned char *data, int size)

{
  unsigned i, j, t, pos;
  unsigned char trans;

  // Kopie von sbox, da sie unten manipuliert wuerde.
  memcpy(m_k, m_sbox, sizeof(m_k));

  // Wenn die Angabe einer Laenge fehlt, wird davon ausgegangen,
  // dass mit einer Zeichenkette gearbeitet wird.
  if (size == 0) {

    size = (int)strlen((char*)data);
  }

  i = j = pos = 0;
  for(; (size - pos) > 0; pos++) {

    i = (i + 1) % 256;
    j = (j + m_k[i]) % 256;
    trans = m_k[i];
    m_k[i] = m_k[j];
    m_k[j] = trans;
    t = (m_k[i] + m_k[j]) % 256;
    data[pos] ^= m_k[t];
  }
}



