#ifndef _ERRORSTATE_H_
#define _ERRORSTATE_H_

/* Error States */
#define ES_NO                          0 // Kein Fehler im Zustand.
#define ES_NO_TEXT                     "Kein Fehler im Zustand."
#define ES_FILE_OPEN                   1 // Oeffnen der Datei gescheitert.
#define ES_FILE_OPEN_TEXT              "Oeffnen der Datei gescheitert."
#define ES_CRC_FAIL                    2 // CRC von Daten falsch.
#define ES_CRC_FAIL_TEXT               "CRC von Daten falsch."
#define ES_FORMAT                      3 // Bereichsfehler bei eingelesenen Daten usw..
#define ES_FORMAT_TEXT                 "Bereichsfehler bei eingelesenen Daten usw.."
#define ES_NO_DATA                     4 // Keine Daten beim laden einer Datei.
#define ES_NO_DATA_TEXT                "Keine Daten beim laden einer Datei."
#define ES_LOAD_DISPLAY_DATA           5 // Laden der Anzeigedaten gescheitert.
#define ES_LOAD_DISPLAY_DATA_TEXT      "Laden der Anzeigedaten gescheitert."
#define ES_LOAD_DEVICE_TEXT            6 // Laden der Anzeigetexte gescheitert.
#define ES_LOAD_DEVICE_TEXT_TEXT       "Laden der Anzeigetexte gescheitert."
#define ES_DEVICE_UNKNOWN              7 // Unbekannter Gerätetyp der Gerätedatei.
#define ES_DEVICE_UNKNOWN_TEXT         "Unbekannter Geraetetyp der Geraetedatei."
#define ES_PROGRAM_OVERFLOW            8 // Programmspeicher Ueberlauf.
#define ES_PROGRAM_OVERFLOW_TEXT       "Programmspeicher Ueberlauf."
#define ES_INTELHEX_MAKE_RECORD        9 // Erzeugen eines IntelHex Datensatzes ist fehlgeschlagen.
#define ES_INTELHEX_MAKE_RECORD_TEXT   "Erzeugen eines IntelHex Datensatzes ist fehlgeschlagen."
#define ES_CRYPT_FIXFAIL              10 // Verschluesselungswert ungueltig.
#define ES_CRYPT_FIXFAIL_TEXT          "Verschluesselungswert ungueltig."
#define ES_CRYPT_NONE                 11 // Entschluesselungsversuch ohne vorherige Verschluesselung.
#define ES_CRYPT_NONE_TEXT             "Entschluesselungsversuch ohne vorherige Verschluesselung."
#define ES_CRYPT_IS                   12 // Verschluesselungsversuch obwohl bereits verschluesselt.
#define ES_CRYPT_IS_TEXT               "Verschluesselungsversuch obwohl bereits verschluesselt."
#define ES_INI_KEY                    13 // Schluesselwert aus Inidatei konnte nicht geladen werden.
#define ES_INI_KEY_TEXT                "Schluesselwert aus Inidatei konnte nicht geladen werden."
#define ES_INI_KEY_VALUE              14 // Schluesselwert aus Inidatei liegt ausserhalb des gueltigen Berreiches.
#define ES_INI_KEY_VALUE_TEXT          "Schluesselwert aus Inidatei liegt ausserhalb des gueltigen Berreiches."
#define ES_SIZE                       15 // Groesse der moeglichen Datenmenge ueberschritten.
#define ES_SIZE_TEXT                   "Groesse der moeglichen Datenmenge ueberschritten."
#define ES_VERSION                    16 // Version der Geraetedatei ist aktueller als erwartet.
#define ES_VERSION_TEXT                "Version der Geraetedatei ist aktueller als erwartet."
#define ES_INTEL_HEX				  17 // Daten oder Endzeile fuer Hexdatei konnte nicht erstellt werden.
#define ES_INTEL_HEX_TEXT			   "Daten oder Endzeile fuer Hexdatei konnte nicht erstellt werden."
#define ES_HEAD_CRC                   18 // Der CRC fuer den Dateikopf schlug fehl.
#define ES_HEAD_CRC_TEXT               "Der CRC fuer den Dateikopf schlug fehl."
#define ES_FW_VERSION_LENGTH          19 // Zeichenkette fuer die Firmwareversion ist zu kurz (< 8) oder zu lang (> 32).
#define ES_FW_VERSION_LENGTH_TEXT      "Zeichenkette fuer die Firmwareversion ist zu kurz (< 8) oder zu lang (> 32)."
#define ES_PROGRAM_CRC                20 // Der CRC fuer den Programm-Flash schlug fehl.
#define ES_PROGRAM_CRC_TEXT            "Der CRC fuer den Programm-Flash schlug fehl."
#define ES_FUNCTION_UNAVAILABLE       21 // Funktion wird nicht unterstuetzt.
#define ES_FUNCTION_UNAVAILABLE_TEXT   "Funktion wird nicht unterstuetzt."
#define ES_LOAD_RAW_FIRMWARE          22 // Laden der Rohen Firmwaredaten gescheitert.
#define ES_LOAD_RAW_FIRMWARE_TEXT      "Laden der Rohen Firmwaredaten gescheitert."
#define ES_VERSION_FILE               23 // Keine gueltige Dateiversionsangabe vorhanden.
#define ES_VERSION_FILE_TEXT           "Keine gueltige Dateiversionsangabe vorhanden."
#define ES_AS_TEXT                    24 // Fehlertext steht ueber string zur Verfuegung.
#define ES_AS_TEXT_TEXT                "Fehlertext steht ueber string zur Verfuegung."
#define ES_FILE_FORMAT                25 // Das Dateiformat ist nicht wie erwartet Intel-Hex.
#define ES_FILE_FORMAT_TEXT            "Das Dateiformat ist nicht wie erwartet Intel-Hex."
#define ES_LINE_FORMAT                26 // Das Format einer Datenzeile ist falsch.
#define ES_LINE_FORMAT_TEXT            "Das Format einer Datenzeile ist falsch."
#define ES_ALLOC_MEM                  27 // Speicherallokation konnte nicht durchgefuehrt werden.
#define ES_ALLOC_MEM_TEXT              "Speicherallokation konnte nicht durchgefuehrt werden."
#define ES_NO_FILE_MATCH              28 // Es wurde keine zutreffende Geraetedatei in diesem Archiv gefunden.
#define ES_NO_FILE_MATCH_TEXT          "Es wurde keine zutreffende Geraetedatei in diesem Archiv gefunden."
#define ES_SERIALIZE_FILE_DATA        29 // Verarbeitung der Dateidaten ist gescheitert.
#define ES_SERIALIZE_FILE_DATA_TEXT    "Verarbeitung der Dateidaten ist gescheitert."

#endif
