#include "firmwareoptions.h"

#include <string>
#include <bitset>

FirmwareOptions::FirmwareOptions()
{
    clear();
}

FirmwareOptions::~FirmwareOptions()
{
}

void FirmwareOptions::clear()
{
    // Dieses Set ist als Merker, welche der Werte vom Gert gelesen oder in das Gert geschrieben werden sollen.
    selectedValues.clear();

    _systemFlags = 0;
    _typeExternalReader = 0;
    _optionIOModule = false;
    _optionTBAdaption = false;
    _optionComServer = false;
    _optionTPWrite = false;
    _optionHTTP = false;
    _optionLanguage = false;
    _optionBiokeyUpdate = false;

    _setupOptionsMask = 0;
    _setupOptions = 0;

    _payableOptionsMask = 0;
    _payableOptions = 0;
}

void FirmwareOptions::setSystemFlags( unsigned int flags )
{
    _systemFlags = flags;
}

unsigned int FirmwareOptions::systemFlags() const
{
    return _systemFlags;
}

void FirmwareOptions::setTypeExternalReader( unsigned char type )
{
    _typeExternalReader = type;
}

unsigned char FirmwareOptions::getTypeExternalReader()
{
    return _typeExternalReader;
}

void FirmwareOptions::setOptionIOModule( unsigned char enabled )
{
    _optionIOModule = enabled;
}

unsigned char FirmwareOptions::getOptionIOModule()
{
    return _optionIOModule;
}

void FirmwareOptions::setOptionTBAdaption( unsigned char enabled )
{
    _optionTBAdaption = enabled;
}

unsigned char FirmwareOptions::getOptionTBAdaption()
{
    return _optionTBAdaption;
}

void FirmwareOptions::setOptionComServer( unsigned char enabled )
{
    _optionComServer = enabled;
}

unsigned char FirmwareOptions::getOptionComServer()
{
    return _optionComServer;
}

void FirmwareOptions::setOptionTPWrite( unsigned char enabled )
{
    _optionTPWrite = enabled;
}

unsigned char FirmwareOptions::getOptionTPWrite()
{
    return _optionTPWrite;
}

void FirmwareOptions::setOptionHTTP( unsigned char enabled )
{
    _optionHTTP = enabled;
}

unsigned char FirmwareOptions::getOptionHTTP()
{
    return _optionHTTP;
}

void FirmwareOptions::setOptionLanguage( unsigned char enabled )
{
    _optionLanguage = enabled;
}

unsigned char FirmwareOptions::getOptionLanguage()
{
    return _optionLanguage;
}

void FirmwareOptions::setOptionBiokeyUpdate( unsigned char enabled )
{
    _optionBiokeyUpdate = enabled;
}

unsigned char FirmwareOptions::getOptionBiokeyUpdate()
{
    return _optionBiokeyUpdate;
}

void FirmwareOptions::setSetupOptions( unsigned short mask, unsigned short options )
{
    _setupOptionsMask = mask;
    _setupOptions = options;
}

unsigned short FirmwareOptions::getSetupOptions( unsigned short mask )
{
    return (_setupOptions & mask);
}

void FirmwareOptions::setPayableOptions( unsigned char mask, unsigned char options )
{
    _payableOptionsMask = mask;
    _payableOptions = options;
}

unsigned char FirmwareOptions::getPayableOptions( unsigned char mask )
{
    return (_payableOptions & mask);
}
